﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Diagnostics;
using InvokeSolutions.Docx;
using InvokeSolutions.Docx.Data;

namespace ConsoleApplication1
{
    class Program
    {
        static void Main(string[] args)
        {
            // create a copy of template file
            File.Copy("template.docx", "ready.docx", true);

            // create datasource
            DocumentDataSource source = new DocumentDataSource();

            source.NewLineStyle = NewLineStyle.Paragraph;

            source["PROPERTY"] = DataItem.ConvertFrom(new[]
                {
                    new { Row = 1, Opt = new int[]{1}, Fish = new[]{ new { Item ="Item \t#1", SI = "£ 100,000" }, new { Item ="Item #2", SI = "£ 35,000" }, new { Item ="Item #3", SI = "£ 1,000,000" }}},
                    new { Row = 2, Opt = new int[]{} , Fish = new[]{ new { Item ="Item #1", SI = "£ \t100,000" }, new { Item ="Item #2", SI = "£ 35,000" }, new { Item ="Item #3", SI = "£ 1,000,000" }}},
                    new { Row = 3, Opt = new int[]{1}, Fish = new[]{ new { Item ="Item #1", SI = "£ 25,000"  }, new { Item ="Item #2", SI = "£ 85,000" }, new { Item ="Item #3", SI = "£ 75,000" }}}
                });

            // small hack to use alternating rows
            (source["PROPERTY"] as TableDataItem).Rows
                .ForEach(r => (r["FISH"] as TableDataItem).DetailsMethod = TableDetailsMethod.AlternateRows);

            // process the document
            DocumentRenderer.ProcessDocument("ready.docx", source);

            Process.Start("ready.docx");
        }
    }
}
