﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using InvokeSolutions.Docx;
using System.IO;
using System.Diagnostics;
using InvokeSolutions.Docx.Data;

namespace SampleOrdersForJonathan
{
    class Program
    {
        static void Main(string[] args)
        {
            //Multi-Dispatch.docx
            File.Copy("order.docx", "order_compiled.docx", true);

            DocumentDataSource dataSource = new DocumentDataSource();

            dataSource["ORDER"] = DataItem.ConvertFrom(
                new[]
                {
                    new 
                    {
                        Id = Guid.NewGuid().ToString().Substring(0, 8),
                        Account = new 
                        {
                            CompanyName = "First ltd."
                        },
                        Customer = new
                        {
                            FirstName = "Joe",
                            SURNAME = "Bloggs"
                        },
                        Item = 
                        new []
                        {
                            new { ProductName = "Product#1", Qty = "31" },
                            new { ProductName = "Product#2", Qty = "71" },
                            new { ProductName = "Product#3", Qty = "33" },
                        },
                        Message = "",
                        DELIVERYADDRESS = 
                        new   
                        {
                            Address1 = "fgdf",
                            Address2 = "dfg",
                            Address3 = "dsfg",
                            TownCity = "dfg",
                            County = "",
                            PostCode = "AA1234"
                        }
                    },
                                        new 
                    {
                        Id = Guid.NewGuid().ToString().Substring(0, 8),
                        Account = new 
                        {
                            CompanyName = "Second ltd. #2"
                        },
                        Customer = new
                        {
                            FirstName = "Joe #2",
                            SURNAME = "Bloggs #2"
                        },
                        Item = 
                        new []
                        {
                            new { ProductName = "Product#21", Qty = "231" },
                            new { ProductName = "Product#22", Qty = "271" },
                            new { ProductName = "Product#23", Qty = "233" },
                        },
                        Message = "",
                        DELIVERYADDRESS = 
                        new   
                        {
                            Address1 = "sdf",
                            Address2 = "sf",
                            Address3 = "sdf",
                            TownCity = "sdf",
                            County = "sdfsd",
                            PostCode = "AA1234"
                        }
                    },
                                        new 
                    {
                        Id = Guid.NewGuid().ToString().Substring(0, 8),
                        Account = new 
                        {
                            CompanyName = "Third ltd."
                        },
                        Customer = new
                        {
                            FirstName = "Joe",
                            SURNAME = "Bloggs"
                        },
                        Item = 
                        new []
                        {
                            new { ProductName = "Product#31", Qty = "331" },
                            new { ProductName = "Product#32", Qty = "371" },
                            new { ProductName = "Product#33", Qty = "333" },
                        },
                        Message = "",
                        DELIVERYADDRESS = 
                        new   
                        {
                            Address1 = "",
                            Address2 = "",
                            Address3 = "",
                            TownCity = "",
                            County = "",
                            PostCode = "AA1234"
                        }
                    }
                });
            
            DocumentRenderer.ProcessDocument("order_compiled.docx", dataSource);

            // launch ms word
            Process.Start("order_compiled.docx");

        }
    }
}
