﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using InvokeSolutions.Docx;
using System.Diagnostics;
using InvokeSolutions.Docx.Data;

namespace docx.nested
{
    class Program
    {
        static void Main(string[] args)
        {
            var sourceFile = "nested_template.docx";

            var destinationFile = "merged.docx";

            File.Copy(sourceFile, destinationFile, true);

            DocumentDataSource dds = new DocumentDataSource();

            dds["COUNTRIES"] =
                DataItem.ConvertFrom(new[] {
                        new { Name = "Australia", 
                            Rates = new [] {
                                new { Income = "0 - $6,000", Rate = 0.0 },
                                new { Income = "$6,001 - $37,000", Rate = 15.0 },
                                new { Income = "$37,001 - $80,000", Rate = 30.0 },
                                new { Income = "$80,001 - $180,000", Rate = 37.0 },
                                new { Income = "$180,001 and over", Rate = 45.0 }
                            }
                        },
                        new { Name = "New Zealand", 
                            Rates = new [] {
                                new { Income = "up to $14,000", Rate = 10.5 },
                                new { Income = "from $14,001 to $48,000", Rate = 17.5 },
                                new { Income = "from $48,001 to $70,000", Rate = 30.0 },
                                new { Income = "$70,001 and over", Rate = 33.0 },
                                new { Income = "No notification", Rate = 45.0 },
                            }
                        },
                });

            DocumentRenderer.ProcessDocument(destinationFile, dds);

            Process.Start(destinationFile);
        }
    }
}
