﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using InvokeSolutions.Docx;
using System.IO;
using System.Diagnostics;
using InvokeSolutions.Docx.Data;

namespace docx.repeater
{
    class Program
    {
        static void Main(string[] args)
        {
            var sourceFile = "repeater_template.docx";

            var destinationFile = "merged.docx";

            File.Copy(sourceFile, destinationFile, true);

            DocumentDataSource dds = new DocumentDataSource();

            dds["STATES"] =
                DataItem.ConvertFrom(new[] {
                        new { Name = "New South Wales", Short = "NSW", Population = 7238819},
                        new { Name = "Victoria", Short = "VIC", Population = 5547527},
                        new { Name = "Queensland", Short = "QLD", Population = 4516361},
                        new { Name = "Western Australia", Short = "WA", Population = 2296411},
                        new { Name = "South Australia", Short = "SA", Population = 1644642},
                        new { Name = "Tasmania", Short = "TAS", Population = 507626},
                        new { Name = "Australian Capital Territory", Short = "ACT", Population = 358894},
                        new { Name = "Northern Territory", Short = "NT", Population = 229675},
                        new { Name = "New Zealand", Short = "NZ", Population = 4414400},
                });

            DocumentRenderer.ProcessDocument(destinationFile, dds);

            Process.Start(destinationFile);
        }
    }
}